## org.h2.index
Class PageBtree

    java.lang.Object
      org.h2.util.CacheObject
          org.h2.store.Record
              org.h2.store.Page
                  org.h2.index.PageBtree

Direct Known Subclasses:
  PageBtreeLeaf, PageBtreeNode

    public abstract class PageBtree

extends Page

A page that contains index data.

Field Summary
`protected Data` `data` The data page.
`protected int` `entryCount` The number of entries.
`protected PageBtreeIndex` `index` The index.
`protected int[]` `offsets` The row offsets.
`protected boolean` `onlyPosition` If only the position of the row is stored in the page
`protected int` `parentPageId` The page number of the parent.
`protected SearchRow[]` `rows` The index data
`protected int` `start` The start of the data area.
`protected boolean` `written` Whether the data page is up-to-date.

Fields inherited from class org.h2.store.Page
`FLAG_LAST, TYPE_BTREE_LEAF, TYPE_BTREE_NODE, TYPE_DATA_LEAF, TYPE_DATA_NODE, TYPE_DATA_OVERFLOW, TYPE_EMPTY, TYPE_FREE_LIST, TYPE_STREAM_DATA, TYPE_STREAM_TRUNK`

Fields inherited from class org.h2.util.CacheObject
`blockCount, cacheQueue, chained, next, previous`

Method Summary
`int` `getMemorySize()` Get the estimated memory size.
`protected void` `readAllRows()` Ensure all rows are read in memory.

Methods inherited from class org.h2.store.Page
`moveTo`

Methods inherited from class org.h2.store.Record
`canRemove, commit, getByteCount, getSessionId, getStorageId, isDeleted, isEmpty, isLogWritten, prepareWrite, setDeleted, setLastLog, setLogWritten, setSessionId, setStorageId, write`

Methods inherited from class org.h2.util.CacheObject
`getBlockCount, getPos, isChanged, isPinned, setBlockCount, setChanged, setPos, sort`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### index

    protected final PageBtreeIndex index

  The index.

### parentPageId

    protected int parentPageId

  The page number of the parent.

### data

    protected final Data data

  The data page.

### offsets

    protected int[] offsets

  The row offsets.

### entryCount

    protected int entryCount

  The number of entries.

### rows

    protected SearchRow[] rows

  The index data

### start

    protected int start

  The start of the data area.

### onlyPosition

    protected boolean onlyPosition

  If only the position of the row is stored in the page

### written

    protected boolean written

  Whether the data page is up-to-date.

Method Detail

### readAllRows

    protected void readAllRows()
                        throws java.sql.SQLException

  Ensure all rows are read in memory.

  Throws:
    `java.sql.SQLException`

### getMemorySize

    public int getMemorySize()

  Get the estimated memory size.

  Overrides:
    `getMemorySize` in class `CacheObject`
  Returns:
    number of double words (4 bytes)